Function initGlobal();
Function unloadGlobal();
Function showActionInfo(String strValue);
Function setSongTicker();
Function debugAlert(String strValue);

Global String strSkinName;
Global Container containerMain;
Global Container containerThinger;
Global Container containerOptions;
Global Layout layoutMainNormal;
Global Layout layoutThingerNormal;
Global Layout layoutOptionsNormal;
Global Text textNormalSongTime;
Global Text textNormalSongName;
Global Text textNormalSongInfo;
Global Text textNormalActionInfo;
Global Timer timerSongTicker;
Global Boolean boolReleaseSongTicker;
Global Boolean boolSongTicker;
Global Map mapNormalVolSeekLevel, mapNormalVolSeekRegion;
Global Region regionVolSeekPosition;

initGlobal() {
	containerMain = System.getContainer("main");
	containerThinger = System.getContainer("thinger");
	containerOptions = System.getContainer("options");
	
	layoutMainNormal = containerMain.getLayout("normal");
	layoutThingerNormal = containerThinger.getLayout("normal");
	layoutOptionsNormal = containerOptions.getLayout("normal");
	
	textNormalSongTime = layoutMainNormal.findObject("player.display.time");
	textNormalSongName = layoutMainNormal.findObject("player.display.songname");
	textNormalSongInfo = layoutMainNormal.findObject("player.display.songinfo");
	textNormalActionInfo = layoutMainNormal.findObject("player.display.actioninfo");
	textNormalActionInfo.hide();
	
	mapNormalVolSeekLevel = new Map;
	mapNormalVolSeekRegion = new Map;
	mapNormalVolSeekLevel.loadMap("player.normal.background.volseek.map");
	mapNormalVolSeekRegion.loadMap("player.normal.background.volseek.region");
	
	regionVolSeekPosition = new Region;
	
	timerSongTicker = new Timer;
	timerSongTicker.setDelay(1000);
	boolReleaseSongTicker = true;
	
	strSkinName = System.getSkinName();
	
	boolSongTicker = System.getPrivateInt(strSkinName, "SongTicker", 1);
	setSongTicker();
}

unloadGlobal() {
	delete timerSongTicker;
	delete mapNormalVolSeekLevel;
	delete mapNormalVolSeekRegion;
	delete regionVolSeekPosition;
}

timerSongTicker.onTimer() {
	if (boolReleaseSongTicker) {
		textNormalActionInfo.hide();
		textNormalSongName.show();
		timerSongTicker.stop();
	}
}

showActionInfo(String strValue) {
	timerSongTicker.stop();
	timerSongTicker.start();
	
	textNormalSongName.hide();
	textNormalActionInfo.show();
	textNormalActionInfo.setText(strValue);
}

setSongTicker() {
	textNormalSongName.setXMLParam("ticker", System.integerToString(boolSongTicker));
	System.setPrivateInt(strSkinName, "SongTicker", boolSongTicker);
}

debugAlert(String strValue) {
	messageBox(strValue, "Debug Alert", 0, "");
}