Function visLightsUpdatePulse(Int intLeftValue, Int intRightValue);
Function initLights();
Function unloadLights();

Global Layer layerNormalLight;
Global Timer timerLights;

initLights() {
	layerNormalLight = layoutMainNormal.findObject("player.background.light");
	
	timerLights = new Timer;
	timerLights.setDelay(50);
	timerLights.start();
}

unloadLights() {
	delete timerLights;
}

timerLights.onTimer() {
	if (layerNormalLight.isVisible() && !intCurrentPulseDisabled) {
		visLightsUpdatePulse(System.getLeftVuMeter(), System.getRightVuMeter());
	}
}

visLightsUpdatePulse(Int intLeftValue, Int intRightValue) {
	if (intLeftValue > layerNormalLight.getAlpha()) {
		layerNormalLight.setAlpha(intLeftValue);
		layerNormalLight.setTargetA(0);
		layerNormalLight.setTargetSpeed(0.5);
		layerNormalLight.gotoTarget();
	}
}