Function initOptions();

Global Button buttonDropShadowsDisabled;
Global Button buttonPulseDisabled;
Global Button buttonSongTickerScrollingDisabled;

Global Int intDefaultDropShadowsDisabled;
Global Int intDefaultPulseDisabled;
Global Int intDefaultSongTickerScrollingDisabled;

Global Int intCurrentDropShadowsDisabled;
Global Int intCurrentPulseDisabled;
Global Int intCurrentFlamesDisabled;
Global Int intCurrentSongTickerScrollingDisabled;

Global Layer layerMainNormalShadow;
Global Layer layerThingerNormalShadow;

initOptions() {
	buttonDropShadowsDisabled = layoutOptionsNormal.findObject("options.checkbox.dropshadows");
	buttonPulseDisabled = layoutOptionsNormal.findObject("options.checkbox.pulse");
	buttonSongTickerScrollingDisabled = layoutOptionsNormal.findObject("options.checkbox.ticker");
	
	intDefaultDropShadowsDisabled = 0;
	intDefaultPulseDisabled = 0;
	intDefaultSongTickerScrollingDisabled = 0;
	
	intCurrentDropShadowsDisabled = System.getPrivateInt("Halloween2003", "DisableDropShadows", intDefaultDropShadowsDisabled);
	intCurrentPulseDisabled = System.getPrivateInt("Halloween2003", "DisablePulse", intDefaultPulseDisabled);
	intCurrentSongTickerScrollingDisabled = System.getPrivateInt("Halloween2003", "DisableSongTickerScrolling", intDefaultSongTickerScrollingDisabled);
	
	layerMainNormalShadow = layoutMainNormal.findObject("player.background.shadow");
	layerThingerNormalShadow = layoutThingerNormal.findObject("thinger.background.shadow");
	
	buttonDropShadowsDisabled.onActivate(intCurrentDropShadowsDisabled);
	buttonPulseDisabled.onActivate(intCurrentPulseDisabled);
	buttonSongTickerScrollingDisabled.onActivate(intCurrentSongTickerScrollingDisabled);
}

buttonDropShadowsDisabled.onActivate(Int intEnabled) {
	layerMainNormalShadow.setXMLParam("visible", System.integerToString(!intEnabled));
	layerThingerNormalShadow.setXMLParam("visible", System.integerToString(!intEnabled));
}

buttonPulseDisabled.onActivate(Int intEnabled) {
	intCurrentPulseDisabled = intEnabled;
}

buttonSongTickerScrollingDisabled.onActivate(Int intEnabled) {
	boolSongTicker = !intEnabled;
	setSongTicker();
}