Function initVolume();
Function volumeUpdate();
Function volumeUpdateUtil(Map mapVolumeRegion, Layer layerVolumeGhost);
Function volumeUpdateXY(Int intPosX, Int intPosY, Map mapVolumeLevel, Map mapVolumeRegion, Layer layerVolumeGhost, Text textSongTicker, Text textVolumeTicker);
Function volumeUpdateRegion(Layer layerVolumeGhost, Map mapVolumeRegion, Float floatVolume);
Function layerVolumeSurfaceLeftButtonDownUtil(Int intPosX, Int intPosY, Map mapVolumeLevel, Map mapVolumeRegion, Layer layerVolumeGhost, Text textSongTicker, Text textVolumeTicker);
Function layerVolumeSurfaceMouseMoveUtil(Int intPosX, Int intPosY, Map mapVolumeLevel, Map mapVolumeRegion, Layer layerVolumeGhost, Text textSongTicker, Text textVolumeTicker);
Function layerVolumeSurfaceLeftButtonUpUtil(Int intPosX, Int intPosY);
Function volumeUpdateTicker(Int intVolume, Text textSongTicker, Text textVolumeTicker);

Global Layer layerNormalVolumeSurface, layerNormalVolumeGhost;
Global Int intVolumeClicked;
Global Int intCurrentVolume;

initVolume() {
	layerNormalVolumeSurface = layoutMainNormal.findObject("player.background.volume.track");
	layerNormalVolumeGhost = layoutMainNormal.findObject("player.background.volume.handle");
	
	volumeUpdate();
}

volumeUpdate() {
	volumeUpdateUtil(mapNormalVolSeekRegion, layerNormalVolumeGhost);
}

volumeUpdateUtil(Map mapVolumeRegion, Layer layerVolumeGhost) {
	intCurrentVolume = System.getVolume();
	volumeUpdateRegion(layerVolumeGhost, mapVolumeRegion, intCurrentVolume);
}

volumeUpdateXY(Int intPosX, Int intPosY, Map mapVolumeLevel, Map mapVolumeRegion, Layer layerVolumeGhost, Text textSongTicker, Text textVolumeTicker) {
	Int intVolume = mapVolumeLevel.getValue(intPosX, intPosY) + 1;
	volumeUpdateRegion(layerVolumeGhost, mapVolumeRegion, intVolume);
	System.setVolume(intVolume - 1);
	volumeUpdateTicker(intVolume, textSongTicker, textVolumeTicker);
}

volumeUpdateRegion(Layer layerVolumeGhost, Map mapVolumeRegion, Float floatVolume) {
	regionVolSeekPosition.loadFromMap(mapVolumeRegion, floatVolume, 1);
	layerVolumeGhost.setRegion(regionVolSeekPosition);
}

volumeUpdateTicker(Int intVolume, Text textSongTicker, Text textVolumeTicker) {
	showActionInfo("Volume: " + System.integerToString(intVolume / 255 * 100) + "%");
}

layerNormalVolumeSurface.onLeftButtonDown(Int intPosX, Int intPosY) {
	layerVolumeSurfaceLeftButtonDownUtil(intPosX, intPosY, mapNormalVolSeekLevel, mapNormalVolSeekRegion, layerNormalVolumeGhost, textNormalSongName, textNormalActionInfo);
}
layerVolumeSurfaceLeftButtonDownUtil(Int intPosX, Int intPosY, Map mapVolumeLevel, Map mapVolumeRegion, Layer layerVolumeGhost, Text textSongTicker, Text textVolumeTicker) {
	intVolumeClicked = 1;
	boolReleaseSongTicker = false;
	volumeUpdateXY(intPosX, intPosY, mapVolumeLevel, mapVolumeRegion, layerVolumeGhost, textSongTicker, textVolumeTicker);
}

layerNormalVolumeSurface.onMouseMove(Int intPosX, Int intPosY) {
	layerVolumeSurfaceMouseMoveUtil(intPosX, intPosY, mapNormalVolSeekLevel, mapNormalVolSeekRegion, layerNormalVolumeGhost, textNormalSongName, textNormalActionInfo);
}
layerVolumeSurfaceMouseMoveUtil(Int intPosX, Int intPosY, Map mapVolumeLevel, Map mapVolumeRegion, Layer layerVolumeGhost, Text textSongTicker, Text textVolumeTicker) {
	if (intVolumeClicked) {
		volumeUpdateXY(intPosX, intPosY, mapVolumeLevel, mapVolumeRegion, layerVolumeGhost, textSongTicker, textVolumeTicker);
	}
}

layerNormalVolumeSurface.onLeftButtonUp(Int intPosX, Int intPosY) {
	layerVolumeSurfaceLeftButtonUpUtil(intPosX, intPosY);
}
layerVolumeSurfaceLeftButtonUpUtil(Int intPosX, Int intPosY) {
	if (!intVolumeClicked) return;
	intVolumeClicked = 0;
	boolReleaseSongTicker = true;
}

System.onVolumeChanged(Int intVolume) {
	volumeUpdate();
	volumeUpdateTicker(intVolume, textNormalSongName, textNormalActionInfo);
}